/*

*/

#include <amxmodx>

#define PLUGIN "Game Big Gui Banner"
#define VERSION "1.1"
#define AUTHOR "Shram"

#define MAX_SIZE 1023
#define BANNER_FILE "resource/background/kel-1a.tga"
#define BANNER_FILE2 "resource/background/kel-1b.tga"
#define BANNER_FILE3 "resource/background/kel-1c.tga"
#define BANNER_FILE4 "resource/background/kel-1d.tga"
#define BANNER_FILE5 "resource/background/kel-2a.tga"
#define BANNER_FILE6 "resource/background/kel-2b.tga"
#define BANNER_FILE7 "resource/background/kel-2c.tga"
#define BANNER_FILE8 "resource/background/kel-2d.tga"
#define BANNER_FILE9 "resource/background/kel-3a.tga"
#define BANNER_FILE10 "resource/background/kel-3b.tga"
#define BANNER_FILE11 "resource/background/kel-3c.tga"
#define BANNER_FILE12 "resource/background/kel-3d.tga"
#define TASKID 6892

new const g_Files[][64] =
{
	"resource/BackgroundLayout.txt",
	"resource/BackgroundLoadingLayout.txt"
	
}

new g_Text[MAX_SIZE], g_CvarEnabled, g_ChangeDelay[33], bool:g_PlayerConnected[33]

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	register_clcmd("change", "Change_LoadingGame")
    
	g_CvarEnabled    = register_cvar("amx_banner", "1")
    
	if (get_pcvar_num(g_CvarEnabled))
		set_task(3.0, "Read_LoadingGame")
}

public client_connect(id)
	client_cmd(id, "cl_allowdownload 1")

public plugin_precache()
{
	precache_generic(BANNER_FILE)
	precache_generic(BANNER_FILE2)
	precache_generic(BANNER_FILE3)
	precache_generic(BANNER_FILE4)
	precache_generic(BANNER_FILE5)
	precache_generic(BANNER_FILE6)
	precache_generic(BANNER_FILE7)
	precache_generic(BANNER_FILE8)
	precache_generic(BANNER_FILE9)
	precache_generic(BANNER_FILE10)
	precache_generic(BANNER_FILE11)
	precache_generic(BANNER_FILE12)
}

public Read_LoadingGame()
{
	new i_File, s_File[128], s_Banner[32], i_Len

	i_Len = strlen(BANNER_FILE)
	i_Len = strlen(BANNER_FILE2)
	i_Len = strlen(BANNER_FILE3)
	i_Len = strlen(BANNER_FILE4)
	i_Len = strlen(BANNER_FILE5)
	i_Len = strlen(BANNER_FILE6)
	i_Len = strlen(BANNER_FILE7)
	i_Len = strlen(BANNER_FILE8)
	i_Len = strlen(BANNER_FILE9)
	i_Len = strlen(BANNER_FILE10)
	i_Len = strlen(BANNER_FILE11)
	i_Len = strlen(BANNER_FILE12)


	get_configsdir(s_File, charsmax(s_File))
	format(s_File, charsmax(s_File), "%s/load.ini", s_File)
	formatex(s_Banner, i_Len - 4, "%s", BANNER_FILE)
	formatex(s_Banner, i_Len - 4, "%s", BANNER_FILE2)
	formatex(s_Banner, i_Len - 4, "%s", BANNER_FILE3)
	formatex(s_Banner, i_Len - 4, "%s", BANNER_FILE4)
	formatex(s_Banner, i_Len - 4, "%s", BANNER_FILE5)
	formatex(s_Banner, i_Len - 4, "%s", BANNER_FILE6)
	formatex(s_Banner, i_Len - 4, "%s", BANNER_FILE7)
	formatex(s_Banner, i_Len - 4, "%s", BANNER_FILE8)
	formatex(s_Banner, i_Len - 4, "%s", BANNER_FILE9)
	formatex(s_Banner, i_Len - 4, "%s", BANNER_FILE10)
	formatex(s_Banner, i_Len - 4, "%s", BANNER_FILE11)
	formatex(s_Banner, i_Len - 4, "%s", BANNER_FILE12)

	i_File = fopen(s_File, "r")
	fgets(i_File, g_Text, MAX_SIZE)
	replace(g_Text, charsmax(g_Text), "banner_file", s_Banner)
	replace(g_Text, charsmax(g_Text), "banner_file2", s_Banner)
	replace(g_Text, charsmax(g_Text), "banner_file3", s_Banner)
	replace(g_Text, charsmax(g_Text), "banner_file4", s_Banner)
	replace(g_Text, charsmax(g_Text), "banner_file5", s_Banner)
	replace(g_Text, charsmax(g_Text), "banner_file6", s_Banner)
	replace(g_Text, charsmax(g_Text), "banner_file7", s_Banner)
	replace(g_Text, charsmax(g_Text), "banner_file8", s_Banner)
	replace(g_Text, charsmax(g_Text), "banner_file9", s_Banner)
	replace(g_Text, charsmax(g_Text), "banner_file10", s_Banner)
	replace(g_Text, charsmax(g_Text), "banner_file11", s_Banner)
	replace(g_Text, charsmax(g_Text), "banner_file12", s_Banner)

	fclose(i_File)
}

public client_putinserver(id)
{	
	if (get_pcvar_num(g_CvarEnabled))
	{
		if (is_user_hltv(id) || is_user_bot(id))
			return PLUGIN_HANDLED
			
		g_ChangeDelay[id] = 0
		g_PlayerConnected[id] = true
		set_task(3.0, "Change_LoadingGame", id)
	}
	
	return PLUGIN_HANDLED
}

public Change_LoadingGame(id)
{
	set_task(1.0, "Change_LoadingGame_Delay", id + TASKID, "", 0, "a", 4)
}
    
public Change_LoadingGame_Delay(taskid)
{
	new id, i

	id = taskid - TASKID
	
	if (!g_PlayerConnected[id])
		return PLUGIN_HANDLED
		
	i = g_ChangeDelay[id]
  
	if (i == 3)
	{
		client_cmd(id, "motdfile motd.txt")
		g_ChangeDelay[id] = 0
	}
	else
	{
		client_cmd(id, "motdfile %s", g_Files[i])
		client_cmd(id, "motd_write %s", g_Text)
        
		g_ChangeDelay[id]++
	}
	
	return PLUGIN_HANDLED
}

public client_disconnect(id)
{
	g_PlayerConnected[id] = false
	remove_task(id + TASKID)
}
 
stock get_configsdir(s_Name[], i_Len)
	return get_localinfo("amxx_configsdir", s_Name, i_Len)
